/*
 * This file was generated automatically by ExtUtils::ParseXS version 3.39 from the
 * contents of Group.xs. Do not edit this file, edit Group.xs instead.
 *
 *    ANY CHANGES MADE HERE WILL BE LOST!
 *
 */

#line 1 "lib/Linux/Netfilter/Log/Group.xs"
#include <arpa/inet.h>
#include <errno.h>
#include <stdint.h>
#include <string.h>
#include <sys/types.h>
#include <libnetfilter_log/libnetfilter_log.h>

#include "EXTERN.h"
#include "perl.h"
#include "XSUB.h"

#include "ppport.h"

#include "linux_netfilter_log.h"

static void _packet_copy_dev(HV *packet, const char *key, struct nflog_data *nfad, uint32_t (*func)(struct nflog_data*))
{
	u_int32_t dev = func(nfad);
	if(dev > 0)
	{
		hv_store(packet, key, strlen(key), newSVuv(dev), 0);
	}
}

static void _packet_copy_u32_buf(HV *packet, const char *key, struct nflog_data *nfad, int (*func)(struct nflog_data*, u_int32_t *buf))
{
	u_int32_t buf;
	if(func(nfad, &buf) == 0)
	{
		hv_store(packet, key, strlen(key), newSVuv(buf), 0);
	}
}

/* Build a Linux::Netfilter::Log::Packet object to pass to the callback.
 *
 * We copy all the data out of nfad rather than wrapping it so the object can
 * remain valid beyond the life of the callback.
*/
static SV *_make_packet_obj(struct nflog_data *nfad)
{
	HV *packet    = newHV();
	SV *packet_sv = sv_bless(newRV_noinc((SV*)(packet)), gv_stashpv("Linux::Netfilter::Log::Packet", 0));

	{
		struct nfulnl_msg_packet_hdr *hdr = nflog_get_msg_packet_hdr(nfad);
		if(hdr != NULL)
		{
			hv_store(packet, "hw_protocol", strlen("hw_protocol"), newSVuv(ntohs(hdr->hw_protocol)), 0);
			hv_store(packet, "hook",        strlen("hook"),        newSVuv(hdr->hook),               0);
		}
	}

	hv_store(packet, "hw_type", strlen("hw_type"), newSVuv(nflog_get_hwtype(nfad)), 0);

	{
		u_int16_t len = nflog_get_msg_packet_hwhdrlen(nfad);
		char *header  = nflog_get_msg_packet_hwhdr(nfad);

		if(len > 0 && header != NULL)
		{
			hv_store(packet, "hw_header", strlen("hw_header"), newSVpvn(header, len), 0);
		}
	}

	hv_store(packet, "mark", strlen("mark"), newSVuv(nflog_get_nfmark(nfad)), 0);

	{
		struct timeval tv;
		if(nflog_get_timestamp(nfad, &tv) == 0)
		{
			hv_store(packet, "timestamp.sec",  strlen("timestamp.sec"),  newSViv(tv.tv_sec),  0);
			hv_store(packet, "timestamp.usec", strlen("timestamp.usec"), newSViv(tv.tv_usec), 0);
		}
	}

	_packet_copy_dev(packet, "indev",      nfad, &nflog_get_indev);
	_packet_copy_dev(packet, "physindev",  nfad, &nflog_get_physindev);
	_packet_copy_dev(packet, "outdev",     nfad, &nflog_get_outdev);
	_packet_copy_dev(packet, "physoutdev", nfad, &nflog_get_physoutdev);

	{
		struct nfulnl_msg_packet_hw *hw = nflog_get_packet_hw(nfad);
		if(hw != NULL)
		{
			hv_store(packet, "hw_addr", strlen("hw_addr"), newSVpvn(hw->hw_addr, sizeof(hw->hw_addr)), 0);
		}
	}

	{
		char *payload;
		int payload_len = nflog_get_payload(nfad, &payload);

		if(payload_len > 0 && payload != NULL)
		{
			hv_store(packet, "payload", strlen("payload"), newSVpvn(payload, payload_len), 0);
		}
	}

	{
		char *prefix = nflog_get_prefix(nfad);
		if(prefix != NULL)
		{
			hv_store(packet, "prefix", strlen("prefix"), newSVpv(prefix, 0), 0);
		}
	}

	_packet_copy_u32_buf(packet, "uid", nfad, &nflog_get_uid);
	_packet_copy_u32_buf(packet, "gid", nfad, &nflog_get_gid);

	_packet_copy_u32_buf(packet, "seq",        nfad, &nflog_get_seq);
	_packet_copy_u32_buf(packet, "seq_global", nfad, &nflog_get_seq_global);

	return packet_sv;
}

static int _callback_proxy(struct nflog_g_handle *gh, struct nfgenmsg *nfmsg, struct nflog_data *nfad, void *data)
{
	SV *callback_func = (SV*)(data);

	dSP;

	ENTER;
	SAVETMPS;

	SV *packet_sv = sv_2mortal(_make_packet_obj(nfad));

	PUSHMARK(SP);
	XPUSHs(packet_sv);
	PUTBACK;

	call_sv(callback_func, G_SCALAR);

	SPAGAIN;

	PUTBACK;
	FREETMPS;
	LEAVE;

	return 0; /* Success */
}

#line 152 "lib/Linux/Netfilter/Log/Group.c"
#ifndef PERL_UNUSED_VAR
#  define PERL_UNUSED_VAR(var) if (0) var = var
#endif

#ifndef dVAR
#  define dVAR		dNOOP
#endif


/* This stuff is not part of the API! You have been warned. */
#ifndef PERL_VERSION_DECIMAL
#  define PERL_VERSION_DECIMAL(r,v,s) (r*1000000 + v*1000 + s)
#endif
#ifndef PERL_DECIMAL_VERSION
#  define PERL_DECIMAL_VERSION \
	  PERL_VERSION_DECIMAL(PERL_REVISION,PERL_VERSION,PERL_SUBVERSION)
#endif
#ifndef PERL_VERSION_GE
#  define PERL_VERSION_GE(r,v,s) \
	  (PERL_DECIMAL_VERSION >= PERL_VERSION_DECIMAL(r,v,s))
#endif
#ifndef PERL_VERSION_LE
#  define PERL_VERSION_LE(r,v,s) \
	  (PERL_DECIMAL_VERSION <= PERL_VERSION_DECIMAL(r,v,s))
#endif

/* XS_INTERNAL is the explicit static-linkage variant of the default
 * XS macro.
 *
 * XS_EXTERNAL is the same as XS_INTERNAL except it does not include
 * "STATIC", ie. it exports XSUB symbols. You probably don't want that
 * for anything but the BOOT XSUB.
 *
 * See XSUB.h in core!
 */


/* TODO: This might be compatible further back than 5.10.0. */
#if PERL_VERSION_GE(5, 10, 0) && PERL_VERSION_LE(5, 15, 1)
#  undef XS_EXTERNAL
#  undef XS_INTERNAL
#  if defined(__CYGWIN__) && defined(USE_DYNAMIC_LOADING)
#    define XS_EXTERNAL(name) __declspec(dllexport) XSPROTO(name)
#    define XS_INTERNAL(name) STATIC XSPROTO(name)
#  endif
#  if defined(__SYMBIAN32__)
#    define XS_EXTERNAL(name) EXPORT_C XSPROTO(name)
#    define XS_INTERNAL(name) EXPORT_C STATIC XSPROTO(name)
#  endif
#  ifndef XS_EXTERNAL
#    if defined(HASATTRIBUTE_UNUSED) && !defined(__cplusplus)
#      define XS_EXTERNAL(name) void name(pTHX_ CV* cv __attribute__unused__)
#      define XS_INTERNAL(name) STATIC void name(pTHX_ CV* cv __attribute__unused__)
#    else
#      ifdef __cplusplus
#        define XS_EXTERNAL(name) extern "C" XSPROTO(name)
#        define XS_INTERNAL(name) static XSPROTO(name)
#      else
#        define XS_EXTERNAL(name) XSPROTO(name)
#        define XS_INTERNAL(name) STATIC XSPROTO(name)
#      endif
#    endif
#  endif
#endif

/* perl >= 5.10.0 && perl <= 5.15.1 */


/* The XS_EXTERNAL macro is used for functions that must not be static
 * like the boot XSUB of a module. If perl didn't have an XS_EXTERNAL
 * macro defined, the best we can do is assume XS is the same.
 * Dito for XS_INTERNAL.
 */
#ifndef XS_EXTERNAL
#  define XS_EXTERNAL(name) XS(name)
#endif
#ifndef XS_INTERNAL
#  define XS_INTERNAL(name) XS(name)
#endif

/* Now, finally, after all this mess, we want an ExtUtils::ParseXS
 * internal macro that we're free to redefine for varying linkage due
 * to the EXPORT_XSUB_SYMBOLS XS keyword. This is internal, use
 * XS_EXTERNAL(name) or XS_INTERNAL(name) in your code if you need to!
 */

#undef XS_EUPXS
#if defined(PERL_EUPXS_ALWAYS_EXPORT)
#  define XS_EUPXS(name) XS_EXTERNAL(name)
#else
   /* default to internal */
#  define XS_EUPXS(name) XS_INTERNAL(name)
#endif

#ifndef PERL_ARGS_ASSERT_CROAK_XS_USAGE
#define PERL_ARGS_ASSERT_CROAK_XS_USAGE assert(cv); assert(params)

/* prototype to pass -Wmissing-prototypes */
STATIC void
S_croak_xs_usage(const CV *const cv, const char *const params);

STATIC void
S_croak_xs_usage(const CV *const cv, const char *const params)
{
    const GV *const gv = CvGV(cv);

    PERL_ARGS_ASSERT_CROAK_XS_USAGE;

    if (gv) {
        const char *const gvname = GvNAME(gv);
        const HV *const stash = GvSTASH(gv);
        const char *const hvname = stash ? HvNAME(stash) : NULL;

        if (hvname)
	    Perl_croak_nocontext("Usage: %s::%s(%s)", hvname, gvname, params);
        else
	    Perl_croak_nocontext("Usage: %s(%s)", gvname, params);
    } else {
        /* Pants. I don't think that it should be possible to get here. */
	Perl_croak_nocontext("Usage: CODE(0x%" UVxf ")(%s)", PTR2UV(cv), params);
    }
}
#undef  PERL_ARGS_ASSERT_CROAK_XS_USAGE

#define croak_xs_usage        S_croak_xs_usage

#endif

/* NOTE: the prototype of newXSproto() is different in versions of perls,
 * so we define a portable version of newXSproto()
 */
#ifdef newXS_flags
#define newXSproto_portable(name, c_impl, file, proto) newXS_flags(name, c_impl, file, proto, 0)
#else
#define newXSproto_portable(name, c_impl, file, proto) (PL_Sv=(SV*)newXS(name, c_impl, file), sv_setpv(PL_Sv, proto), (CV*)PL_Sv)
#endif /* !defined(newXS_flags) */

#if PERL_VERSION_LE(5, 21, 5)
#  define newXS_deffile(a,b) Perl_newXS(aTHX_ a,b,file)
#else
#  define newXS_deffile(a,b) Perl_newXS_deffile(aTHX_ a,b)
#endif

#line 296 "lib/Linux/Netfilter/Log/Group.c"

XS_EUPXS(XS_Linux__Netfilter__Log__Group_DESTROY); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Linux__Netfilter__Log__Group_DESTROY)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "self");
    {
	struct perl_nflog_group *	self;

	if(sv_isobject(ST(0))
		&& sv_derived_from(ST(0), "Linux::Netfilter::Log::Group")
		&& SvTYPE(SvRV(ST(0))) == SVt_PVMG)
	{
		self = (struct perl_nflog_group *)SvIV((SV*)SvRV( ST(0) ));
	}
	else{
		croak("Linux::Netfilter::Log::Group::DESTROY() -- self is not a Linux::Netfilter::Log::Group");
	}
;
#line 146 "lib/Linux/Netfilter/Log/Group.xs"
		if(nflog_unbind_group(self->g_handle) == -1)
		{
			warn("nflog_unbind_group: %s", strerror(errno));
		}

		if(self->callback != NULL)
		{
			SvREFCNT_dec(self->callback);
		}

		SvREFCNT_dec(self->handle);

		Safefree(self);
#line 331 "lib/Linux/Netfilter/Log/Group.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Linux__Netfilter__Log__Group_callback_register); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Linux__Netfilter__Log__Group_callback_register)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "self, cb");
    {
	struct perl_nflog_group *	self;
	CV *	cb;

	if(sv_isobject(ST(0))
		&& sv_derived_from(ST(0), "Linux::Netfilter::Log::Group")
		&& SvTYPE(SvRV(ST(0))) == SVt_PVMG)
	{
		self = (struct perl_nflog_group *)SvIV((SV*)SvRV( ST(0) ));
	}
	else{
		croak("Linux::Netfilter::Log::Group::callback_register() -- self is not a Linux::Netfilter::Log::Group");
	}
;

	STMT_START {
                HV *st;
                GV *gvp;
		SV * const xsub_tmp_sv = ST(1);
		SvGETMAGIC(xsub_tmp_sv);
                cb = sv_2cv(xsub_tmp_sv, &st, &gvp, 0);
		if (!cb) {
		    Perl_croak_nocontext("%s: %s is not a CODE reference",
				"Linux::Netfilter::Log::Group::callback_register",
				"cb");
		}
	} STMT_END
;
#line 162 "lib/Linux/Netfilter/Log/Group.xs"
		if(nflog_callback_register(self->g_handle, &_callback_proxy, (void*)(cb)) == -1)
		{
			croak("nflog_callback_register: %s", strerror(errno));
		}

		if(self->callback != NULL)
		{
			SvREFCNT_dec(self->callback);
		}

		SvREFCNT_inc(cb);
		self->callback = cb;
#line 384 "lib/Linux/Netfilter/Log/Group.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Linux__Netfilter__Log__Group_set_mode); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Linux__Netfilter__Log__Group_set_mode)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "self, mode, range");
    {
	struct perl_nflog_group *	self;
	uint8_t	mode = (uint8_t)SvUV(ST(1))
;
	uint32_t	range = (uint32_t)SvUV(ST(2))
;

	if(sv_isobject(ST(0))
		&& sv_derived_from(ST(0), "Linux::Netfilter::Log::Group")
		&& SvTYPE(SvRV(ST(0))) == SVt_PVMG)
	{
		self = (struct perl_nflog_group *)SvIV((SV*)SvRV( ST(0) ));
	}
	else{
		croak("Linux::Netfilter::Log::Group::set_mode() -- self is not a Linux::Netfilter::Log::Group");
	}
;
#line 177 "lib/Linux/Netfilter/Log/Group.xs"
		if(nflog_set_mode(self->g_handle, mode, range) == -1)
		{
			croak("nflog_set_mode: %s", strerror(errno));
		}
#line 418 "lib/Linux/Netfilter/Log/Group.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Linux__Netfilter__Log__Group_set_nlbufsiz); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Linux__Netfilter__Log__Group_set_nlbufsiz)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "self, nlbufsiz");
    {
	struct perl_nflog_group *	self;
	uint32_t	nlbufsiz = (uint32_t)SvUV(ST(1))
;

	if(sv_isobject(ST(0))
		&& sv_derived_from(ST(0), "Linux::Netfilter::Log::Group")
		&& SvTYPE(SvRV(ST(0))) == SVt_PVMG)
	{
		self = (struct perl_nflog_group *)SvIV((SV*)SvRV( ST(0) ));
	}
	else{
		croak("Linux::Netfilter::Log::Group::set_nlbufsiz() -- self is not a Linux::Netfilter::Log::Group");
	}
;
#line 184 "lib/Linux/Netfilter/Log/Group.xs"
		if(nflog_set_nlbufsiz(self->g_handle, nlbufsiz) == -1)
		{
			croak("nflog_set_nlbufsiz: %s", strerror(errno));
		}
#line 450 "lib/Linux/Netfilter/Log/Group.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Linux__Netfilter__Log__Group_set_qthresh); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Linux__Netfilter__Log__Group_set_qthresh)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "self, qthresh");
    {
	struct perl_nflog_group *	self;
	uint32_t	qthresh = (uint32_t)SvUV(ST(1))
;

	if(sv_isobject(ST(0))
		&& sv_derived_from(ST(0), "Linux::Netfilter::Log::Group")
		&& SvTYPE(SvRV(ST(0))) == SVt_PVMG)
	{
		self = (struct perl_nflog_group *)SvIV((SV*)SvRV( ST(0) ));
	}
	else{
		croak("Linux::Netfilter::Log::Group::set_qthresh() -- self is not a Linux::Netfilter::Log::Group");
	}
;
#line 191 "lib/Linux/Netfilter/Log/Group.xs"
		if(nflog_set_qthresh(self->g_handle, qthresh) == -1)
		{
			croak("nflog_set_qthresh: %s", strerror(errno));
		}
#line 482 "lib/Linux/Netfilter/Log/Group.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Linux__Netfilter__Log__Group_set_timeout); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Linux__Netfilter__Log__Group_set_timeout)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "self, timeout");
    {
	struct perl_nflog_group *	self;
	uint32_t	timeout = (uint32_t)SvUV(ST(1))
;

	if(sv_isobject(ST(0))
		&& sv_derived_from(ST(0), "Linux::Netfilter::Log::Group")
		&& SvTYPE(SvRV(ST(0))) == SVt_PVMG)
	{
		self = (struct perl_nflog_group *)SvIV((SV*)SvRV( ST(0) ));
	}
	else{
		croak("Linux::Netfilter::Log::Group::set_timeout() -- self is not a Linux::Netfilter::Log::Group");
	}
;
#line 198 "lib/Linux/Netfilter/Log/Group.xs"
		if(nflog_set_timeout(self->g_handle, timeout) == -1)
		{
			croak("nflog_set_timeout: %s", strerror(errno));
		}
#line 514 "lib/Linux/Netfilter/Log/Group.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Linux__Netfilter__Log__Group_set_flags); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Linux__Netfilter__Log__Group_set_flags)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "self, flags");
    {
	struct perl_nflog_group *	self;
	uint16_t	flags = (uint16_t)SvUV(ST(1))
;

	if(sv_isobject(ST(0))
		&& sv_derived_from(ST(0), "Linux::Netfilter::Log::Group")
		&& SvTYPE(SvRV(ST(0))) == SVt_PVMG)
	{
		self = (struct perl_nflog_group *)SvIV((SV*)SvRV( ST(0) ));
	}
	else{
		croak("Linux::Netfilter::Log::Group::set_flags() -- self is not a Linux::Netfilter::Log::Group");
	}
;
#line 205 "lib/Linux/Netfilter/Log/Group.xs"
		if(nflog_set_flags(self->g_handle, flags) == -1)
		{
			croak("nflog_set_flags: %s", strerror(errno));
		}
#line 546 "lib/Linux/Netfilter/Log/Group.c"
    }
    XSRETURN_EMPTY;
}

#ifdef __cplusplus
extern "C"
#endif
XS_EXTERNAL(boot_Linux__Netfilter__Log__Group); /* prototype to pass -Wmissing-prototypes */
XS_EXTERNAL(boot_Linux__Netfilter__Log__Group)
{
#if PERL_VERSION_LE(5, 21, 5)
    dVAR; dXSARGS;
#else
    dVAR; dXSBOOTARGSXSAPIVERCHK;
#endif
#if (PERL_REVISION == 5 && PERL_VERSION < 9)
    char* file = __FILE__;
#else
    const char* file = __FILE__;
#endif

    PERL_UNUSED_VAR(file);

    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(items); /* -W */
#if PERL_VERSION_LE(5, 21, 5)
    XS_VERSION_BOOTCHECK;
#  ifdef XS_APIVERSION_BOOTCHECK
    XS_APIVERSION_BOOTCHECK;
#  endif
#endif

        newXS_deffile("Linux::Netfilter::Log::Group::DESTROY", XS_Linux__Netfilter__Log__Group_DESTROY);
        newXS_deffile("Linux::Netfilter::Log::Group::callback_register", XS_Linux__Netfilter__Log__Group_callback_register);
        newXS_deffile("Linux::Netfilter::Log::Group::set_mode", XS_Linux__Netfilter__Log__Group_set_mode);
        newXS_deffile("Linux::Netfilter::Log::Group::set_nlbufsiz", XS_Linux__Netfilter__Log__Group_set_nlbufsiz);
        newXS_deffile("Linux::Netfilter::Log::Group::set_qthresh", XS_Linux__Netfilter__Log__Group_set_qthresh);
        newXS_deffile("Linux::Netfilter::Log::Group::set_timeout", XS_Linux__Netfilter__Log__Group_set_timeout);
        newXS_deffile("Linux::Netfilter::Log::Group::set_flags", XS_Linux__Netfilter__Log__Group_set_flags);
#if PERL_VERSION_LE(5, 21, 5)
#  if PERL_VERSION_GE(5, 9, 0)
    if (PL_unitcheckav)
        call_list(PL_scopestack_ix, PL_unitcheckav);
#  endif
    XSRETURN_YES;
#else
    Perl_xs_boot_epilog(aTHX_ ax);
#endif
}

